////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 1.8
//  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard 
//  /   /         Filename : mgt_32gbps_16bit_1to12_top.v
// /___/   /\     Timestamp : 
// \   \  /  \ 
//  \___\/\___\ 
//
//
// Module MGT_32GBPS_16BIT_1TO12_TOP
// Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard
// 
// 
// (c) Copyright 2009-2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES. 


`timescale 1ns / 1ps
`define DLY #1


//***********************************Entity Declaration************************

module MGT_32GBPS_16BIT_1TO12_TOP #
(
    parameter EXAMPLE_CONFIG_INDEPENDENT_LANES          =   1,   //configuration for frame gen and check
    parameter EXAMPLE_LANE_WITH_START_CHAR              =   0,    // specifies lane with unique start frame char
    parameter EXAMPLE_WORDS_IN_BRAM                     =   512,  // specifies amount of data in BRAM
    parameter EXAMPLE_SIM_GTXRESET_SPEEDUP              =   0,    // simulation setting for GTX SecureIP model
    parameter EXAMPLE_USE_CHIPSCOPE                     =   1,    // Set to 1 to use Chipscope to drive resets
    parameter ALIGNER_WAIT                              =   8'd32 // To set the wait cycles in aligner
)
(
    input wire  Q3_CLK0_MGTREFCLK_PAD_N_IN,
    input wire  Q3_CLK0_MGTREFCLK_PAD_P_IN,
    input wire  GTXTXRESET_IN,
    input wire  GTXRXRESET_IN,
    output wire TRACK_DATA_OUT,
    input  wire [11:0]  RXN_IN,
    input  wire [11:0]  RXP_IN,
    output wire [11:0]  TXN_OUT,
    output wire [11:0]  TXP_OUT
);


//************************** Register Declarations ****************************

    reg     [84:0]  ila_in_r;

// * max_fanout = 1 *
    reg             gtx0_rxresetdone_i_r;
    reg             gtx0_rxresetdone_r;
    reg             gtx0_rxresetdone_r2;
    reg             gtx0_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx1_rxresetdone_i_r;
    reg             gtx1_rxresetdone_r;
    reg             gtx1_rxresetdone_r2;
    reg             gtx1_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx2_rxresetdone_i_r;
    reg             gtx2_rxresetdone_r;
    reg             gtx2_rxresetdone_r2;
    reg             gtx2_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx3_rxresetdone_i_r;
    reg             gtx3_rxresetdone_r;
    reg             gtx3_rxresetdone_r2;
    reg             gtx3_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx4_rxresetdone_i_r;
    reg             gtx4_rxresetdone_r;
    reg             gtx4_rxresetdone_r2;
    reg             gtx4_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx5_rxresetdone_i_r;
    reg             gtx5_rxresetdone_r;
    reg             gtx5_rxresetdone_r2;
    reg             gtx5_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx6_rxresetdone_i_r;
    reg             gtx6_rxresetdone_r;
    reg             gtx6_rxresetdone_r2;
    reg             gtx6_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx7_rxresetdone_i_r;
    reg             gtx7_rxresetdone_r;
    reg             gtx7_rxresetdone_r2;
    reg             gtx7_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx8_rxresetdone_i_r;
    reg             gtx8_rxresetdone_r;
    reg             gtx8_rxresetdone_r2;
    reg             gtx8_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx9_rxresetdone_i_r;
    reg             gtx9_rxresetdone_r;
    reg             gtx9_rxresetdone_r2;
    reg             gtx9_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx10_rxresetdone_i_r;
    reg             gtx10_rxresetdone_r;
    reg             gtx10_rxresetdone_r2;
    reg             gtx10_rxresetdone_r3;
// * max_fanout = 1 *
    reg             gtx11_rxresetdone_i_r;
    reg             gtx11_rxresetdone_r;
    reg             gtx11_rxresetdone_r2;
    reg             gtx11_rxresetdone_r3;
    //------------------------ MGT Wrapper Wires ------------------------------
    //________________________________________________________________________
    //________________________________________________________________________
    //GTX0   (X0Y8)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx0_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx0_rxcharisk_i;
    wire    [1:0]   gtx0_rxdisperr_i;
    wire    [1:0]   gtx0_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx0_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx0_rxenmcommaalign_i;
    wire            gtx0_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx0_rxdata_i;
    wire            gtx0_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx0_gtxrxreset_i;
    wire            gtx0_pllrxreset_i;
    wire            gtx0_rxplllkdet_i;
    wire            gtx0_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX1   (X0Y9)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx1_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx1_rxcharisk_i;
    wire    [1:0]   gtx1_rxdisperr_i;
    wire    [1:0]   gtx1_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx1_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx1_rxenmcommaalign_i;
    wire            gtx1_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx1_rxdata_i;
    wire            gtx1_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx1_gtxrxreset_i;
    wire            gtx1_pllrxreset_i;
    wire            gtx1_rxplllkdet_i;
    wire            gtx1_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX2   (X0Y10)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx2_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx2_rxcharisk_i;
    wire    [1:0]   gtx2_rxdisperr_i;
    wire    [1:0]   gtx2_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx2_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx2_rxenmcommaalign_i;
    wire            gtx2_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx2_rxdata_i;
    wire            gtx2_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx2_gtxrxreset_i;
    wire            gtx2_pllrxreset_i;
    wire            gtx2_rxplllkdet_i;
    wire            gtx2_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX3   (X0Y11)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx3_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx3_rxcharisk_i;
    wire    [1:0]   gtx3_rxdisperr_i;
    wire    [1:0]   gtx3_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx3_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx3_rxenmcommaalign_i;
    wire            gtx3_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx3_rxdata_i;
    wire            gtx3_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx3_gtxrxreset_i;
    wire            gtx3_pllrxreset_i;
    wire            gtx3_rxplllkdet_i;
    wire            gtx3_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX4   (X0Y12)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx4_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx4_rxcharisk_i;
    wire    [1:0]   gtx4_rxdisperr_i;
    wire    [1:0]   gtx4_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx4_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx4_rxenmcommaalign_i;
    wire            gtx4_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx4_rxdata_i;
    wire            gtx4_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx4_gtxrxreset_i;
    wire            gtx4_pllrxreset_i;
    wire            gtx4_rxplllkdet_i;
    wire            gtx4_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX5   (X0Y13)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx5_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx5_rxcharisk_i;
    wire    [1:0]   gtx5_rxdisperr_i;
    wire    [1:0]   gtx5_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx5_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx5_rxenmcommaalign_i;
    wire            gtx5_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx5_rxdata_i;
    wire            gtx5_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx5_gtxrxreset_i;
    wire            gtx5_pllrxreset_i;
    wire            gtx5_rxplllkdet_i;
    wire            gtx5_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX6   (X0Y14)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx6_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx6_rxcharisk_i;
    wire    [1:0]   gtx6_rxdisperr_i;
    wire    [1:0]   gtx6_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx6_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx6_rxenmcommaalign_i;
    wire            gtx6_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx6_rxdata_i;
    wire            gtx6_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx6_gtxrxreset_i;
    wire            gtx6_pllrxreset_i;
    wire            gtx6_rxplllkdet_i;
    wire            gtx6_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX7   (X0Y15)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx7_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx7_rxcharisk_i;
    wire    [1:0]   gtx7_rxdisperr_i;
    wire    [1:0]   gtx7_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx7_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx7_rxenmcommaalign_i;
    wire            gtx7_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx7_rxdata_i;
    wire            gtx7_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx7_gtxrxreset_i;
    wire            gtx7_pllrxreset_i;
    wire            gtx7_rxplllkdet_i;
    wire            gtx7_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX8   (X0Y16)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx8_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx8_rxcharisk_i;
    wire    [1:0]   gtx8_rxdisperr_i;
    wire    [1:0]   gtx8_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx8_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx8_rxenmcommaalign_i;
    wire            gtx8_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx8_rxdata_i;
    wire            gtx8_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx8_gtxrxreset_i;
    wire            gtx8_pllrxreset_i;
    wire            gtx8_rxplllkdet_i;
    wire            gtx8_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX9   (X0Y17)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx9_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx9_rxcharisk_i;
    wire    [1:0]   gtx9_rxdisperr_i;
    wire    [1:0]   gtx9_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx9_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx9_rxenmcommaalign_i;
    wire            gtx9_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx9_rxdata_i;
    wire            gtx9_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx9_gtxrxreset_i;
    wire            gtx9_pllrxreset_i;
    wire            gtx9_rxplllkdet_i;
    wire            gtx9_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX10   (X0Y18)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx10_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx10_rxcharisk_i;
    wire    [1:0]   gtx10_rxdisperr_i;
    wire    [1:0]   gtx10_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx10_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx10_rxenmcommaalign_i;
    wire            gtx10_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx10_rxdata_i;
    wire            gtx10_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx10_gtxrxreset_i;
    wire            gtx10_pllrxreset_i;
    wire            gtx10_rxplllkdet_i;
    wire            gtx10_rxresetdone_i;


    //________________________________________________________________________
    //________________________________________________________________________
    //GTX11   (X0Y19)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx11_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   gtx11_rxcharisk_i;
    wire    [1:0]   gtx11_rxdisperr_i;
    wire    [1:0]   gtx11_rxnotintable_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx11_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx11_rxenmcommaalign_i;
    wire            gtx11_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  gtx11_rxdata_i;
    wire            gtx11_rxrecclk_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx11_gtxrxreset_i;
    wire            gtx11_pllrxreset_i;
    wire            gtx11_rxplllkdet_i;
    wire            gtx11_rxresetdone_i;




    //----------------------------- Global Signals -----------------------------
    wire            gtx0_tx_system_reset_c;
    wire            gtx0_rx_system_reset_c;
    wire            gtx1_tx_system_reset_c;
    wire            gtx1_rx_system_reset_c;
    wire            gtx2_tx_system_reset_c;
    wire            gtx2_rx_system_reset_c;
    wire            gtx3_tx_system_reset_c;
    wire            gtx3_rx_system_reset_c;
    wire            gtx4_tx_system_reset_c;
    wire            gtx4_rx_system_reset_c;
    wire            gtx5_tx_system_reset_c;
    wire            gtx5_rx_system_reset_c;
    wire            gtx6_tx_system_reset_c;
    wire            gtx6_rx_system_reset_c;
    wire            gtx7_tx_system_reset_c;
    wire            gtx7_rx_system_reset_c;
    wire            gtx8_tx_system_reset_c;
    wire            gtx8_rx_system_reset_c;
    wire            gtx9_tx_system_reset_c;
    wire            gtx9_rx_system_reset_c;
    wire            gtx10_tx_system_reset_c;
    wire            gtx10_rx_system_reset_c;
    wire            gtx11_tx_system_reset_c;
    wire            gtx11_rx_system_reset_c;
    wire            tied_to_ground_i;
    wire    [63:0]  tied_to_ground_vec_i;
    wire            tied_to_vcc_i;
    wire    [7:0]   tied_to_vcc_vec_i;
    wire            drp_clk_in_i;

    //--------------------------- User Clocks ---------------------------------
    wire            gtx0_rxusrclk2_i;
    wire            gtx1_rxusrclk2_i;
    wire            gtx2_rxusrclk2_i;
    wire            gtx3_rxusrclk2_i;
    wire            gtx4_rxusrclk2_i;
    wire            gtx5_rxusrclk2_i;
    wire            gtx6_rxusrclk2_i;
    wire            gtx7_rxusrclk2_i;
    wire            gtx8_rxusrclk2_i;
    wire            gtx9_rxusrclk2_i;
    wire            gtx10_rxusrclk2_i;
    wire            gtx11_rxusrclk2_i;
    wire            rxrecclk_mmcm0_locked_i;
    wire            rxrecclk_mmcm0_reset_i;
    wire            gtx0_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm1_locked_i;
    wire            rxrecclk_mmcm1_reset_i;
    wire            gtx1_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm2_locked_i;
    wire            rxrecclk_mmcm2_reset_i;
    wire            gtx2_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm3_locked_i;
    wire            rxrecclk_mmcm3_reset_i;
    wire            gtx3_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm4_locked_i;
    wire            rxrecclk_mmcm4_reset_i;
    wire            gtx4_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm5_locked_i;
    wire            rxrecclk_mmcm5_reset_i;
    wire            gtx5_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm6_locked_i;
    wire            rxrecclk_mmcm6_reset_i;
    wire            gtx6_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm7_locked_i;
    wire            rxrecclk_mmcm7_reset_i;
    wire            gtx7_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm8_locked_i;
    wire            rxrecclk_mmcm8_reset_i;
    wire            gtx8_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm9_locked_i;
    wire            rxrecclk_mmcm9_reset_i;
    wire            gtx9_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm10_locked_i;
    wire            rxrecclk_mmcm10_reset_i;
    wire            gtx10_rxrecclk_to_mmcm_i;
    wire            rxrecclk_mmcm11_locked_i;
    wire            rxrecclk_mmcm11_reset_i;
    wire            gtx11_rxrecclk_to_mmcm_i;


    //--------------------------- Reference Clocks ----------------------------
    
    wire            q3_clk0_refclk_i;
    //--------------------- Frame check/gen Module Signals --------------------
    wire            gtx0_matchn_i;
    
    wire    [2:0]   gtx0_txcharisk_float_i;
    
    wire    [31:0]  gtx0_txdata_float_i;
    
    
    wire            gtx0_block_sync_i;
    wire            gtx0_track_data_i;
    wire    [7:0]   gtx0_error_count_i;
    wire            gtx0_frame_check_reset_i;
    wire            gtx0_inc_in_i;
    wire            gtx0_inc_out_i;
    wire    [15:0]  gtx0_unscrambled_data_i;

    wire            gtx1_matchn_i;
    
    wire    [2:0]   gtx1_txcharisk_float_i;
    
    wire    [31:0]  gtx1_txdata_float_i;
    
    
    wire            gtx1_block_sync_i;
    wire            gtx1_track_data_i;
    wire    [7:0]   gtx1_error_count_i;
    wire            gtx1_frame_check_reset_i;
    wire            gtx1_inc_in_i;
    wire            gtx1_inc_out_i;
    wire    [15:0]  gtx1_unscrambled_data_i;

    wire            gtx2_matchn_i;
    
    wire    [2:0]   gtx2_txcharisk_float_i;
    
    wire    [31:0]  gtx2_txdata_float_i;
    
    
    wire            gtx2_block_sync_i;
    wire            gtx2_track_data_i;
    wire    [7:0]   gtx2_error_count_i;
    wire            gtx2_frame_check_reset_i;
    wire            gtx2_inc_in_i;
    wire            gtx2_inc_out_i;
    wire    [15:0]  gtx2_unscrambled_data_i;

    wire            gtx3_matchn_i;
    
    wire    [2:0]   gtx3_txcharisk_float_i;
    
    wire    [31:0]  gtx3_txdata_float_i;
    
    
    wire            gtx3_block_sync_i;
    wire            gtx3_track_data_i;
    wire    [7:0]   gtx3_error_count_i;
    wire            gtx3_frame_check_reset_i;
    wire            gtx3_inc_in_i;
    wire            gtx3_inc_out_i;
    wire    [15:0]  gtx3_unscrambled_data_i;

    wire            gtx4_matchn_i;
    
    wire    [2:0]   gtx4_txcharisk_float_i;
    
    wire    [31:0]  gtx4_txdata_float_i;
    
    
    wire            gtx4_block_sync_i;
    wire            gtx4_track_data_i;
    wire    [7:0]   gtx4_error_count_i;
    wire            gtx4_frame_check_reset_i;
    wire            gtx4_inc_in_i;
    wire            gtx4_inc_out_i;
    wire    [15:0]  gtx4_unscrambled_data_i;

    wire            gtx5_matchn_i;
    
    wire    [2:0]   gtx5_txcharisk_float_i;
    
    wire    [31:0]  gtx5_txdata_float_i;
    
    
    wire            gtx5_block_sync_i;
    wire            gtx5_track_data_i;
    wire    [7:0]   gtx5_error_count_i;
    wire            gtx5_frame_check_reset_i;
    wire            gtx5_inc_in_i;
    wire            gtx5_inc_out_i;
    wire    [15:0]  gtx5_unscrambled_data_i;

    wire            gtx6_matchn_i;
    
    wire    [2:0]   gtx6_txcharisk_float_i;
    
    wire    [31:0]  gtx6_txdata_float_i;
    
    
    wire            gtx6_block_sync_i;
    wire            gtx6_track_data_i;
    wire    [7:0]   gtx6_error_count_i;
    wire            gtx6_frame_check_reset_i;
    wire            gtx6_inc_in_i;
    wire            gtx6_inc_out_i;
    wire    [15:0]  gtx6_unscrambled_data_i;

    wire            gtx7_matchn_i;
    
    wire    [2:0]   gtx7_txcharisk_float_i;
    
    wire    [31:0]  gtx7_txdata_float_i;
    
    
    wire            gtx7_block_sync_i;
    wire            gtx7_track_data_i;
    wire    [7:0]   gtx7_error_count_i;
    wire            gtx7_frame_check_reset_i;
    wire            gtx7_inc_in_i;
    wire            gtx7_inc_out_i;
    wire    [15:0]  gtx7_unscrambled_data_i;

    wire            gtx8_matchn_i;
    
    wire    [2:0]   gtx8_txcharisk_float_i;
    
    wire    [31:0]  gtx8_txdata_float_i;
    
    
    wire            gtx8_block_sync_i;
    wire            gtx8_track_data_i;
    wire    [7:0]   gtx8_error_count_i;
    wire            gtx8_frame_check_reset_i;
    wire            gtx8_inc_in_i;
    wire            gtx8_inc_out_i;
    wire    [15:0]  gtx8_unscrambled_data_i;

    wire            gtx9_matchn_i;
    
    wire    [2:0]   gtx9_txcharisk_float_i;
    
    wire    [31:0]  gtx9_txdata_float_i;
    
    
    wire            gtx9_block_sync_i;
    wire            gtx9_track_data_i;
    wire    [7:0]   gtx9_error_count_i;
    wire            gtx9_frame_check_reset_i;
    wire            gtx9_inc_in_i;
    wire            gtx9_inc_out_i;
    wire    [15:0]  gtx9_unscrambled_data_i;

    wire            gtx10_matchn_i;
    
    wire    [2:0]   gtx10_txcharisk_float_i;
    
    wire    [31:0]  gtx10_txdata_float_i;
    
    
    wire            gtx10_block_sync_i;
    wire            gtx10_track_data_i;
    wire    [7:0]   gtx10_error_count_i;
    wire            gtx10_frame_check_reset_i;
    wire            gtx10_inc_in_i;
    wire            gtx10_inc_out_i;
    wire    [15:0]  gtx10_unscrambled_data_i;

    wire            gtx11_matchn_i;
    
    wire    [2:0]   gtx11_txcharisk_float_i;
    
    wire    [31:0]  gtx11_txdata_float_i;
    
    
    wire            gtx11_block_sync_i;
    wire            gtx11_track_data_i;
    wire    [7:0]   gtx11_error_count_i;
    wire            gtx11_frame_check_reset_i;
    wire            gtx11_inc_in_i;
    wire            gtx11_inc_out_i;
    wire    [15:0]  gtx11_unscrambled_data_i;

    wire            reset_on_data_error_i;
    wire            track_data_out_i;


    //--------------------- Chipscope Signals ---------------------------------

    wire    [35:0]  tx_data_vio_control_i;
    wire    [35:0]  rx_data_vio_control_i;
    wire    [35:0]  shared_vio_control_i;
    wire    [35:0]  ila_control_i;
    wire    [31:0]  tx_data_vio_async_in_i;
    wire    [31:0]  tx_data_vio_sync_in_i;
    wire    [31:0]  tx_data_vio_async_out_i;
    wire    [31:0]  tx_data_vio_sync_out_i;
    wire    [31:0]  rx_data_vio_async_in_i;
    wire    [31:0]  rx_data_vio_sync_in_i;
    wire    [31:0]  rx_data_vio_async_out_i;
    wire    [31:0]  rx_data_vio_sync_out_i;
    wire    [31:0]  shared_vio_in_i;
    wire    [31:0]  shared_vio_out_i;
    wire    [84:0]  ila_in_i;

    wire    [31:0]  gtx0_tx_data_vio_async_in_i;
    wire    [31:0]  gtx0_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx0_tx_data_vio_async_out_i;
    wire    [31:0]  gtx0_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx0_rx_data_vio_async_in_i;
    wire    [31:0]  gtx0_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx0_rx_data_vio_async_out_i;
    wire    [31:0]  gtx0_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx0_ila_in_i;

    wire    [31:0]  gtx1_tx_data_vio_async_in_i;
    wire    [31:0]  gtx1_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx1_tx_data_vio_async_out_i;
    wire    [31:0]  gtx1_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx1_rx_data_vio_async_in_i;
    wire    [31:0]  gtx1_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx1_rx_data_vio_async_out_i;
    wire    [31:0]  gtx1_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx1_ila_in_i;

    wire    [31:0]  gtx2_tx_data_vio_async_in_i;
    wire    [31:0]  gtx2_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx2_tx_data_vio_async_out_i;
    wire    [31:0]  gtx2_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx2_rx_data_vio_async_in_i;
    wire    [31:0]  gtx2_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx2_rx_data_vio_async_out_i;
    wire    [31:0]  gtx2_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx2_ila_in_i;

    wire    [31:0]  gtx3_tx_data_vio_async_in_i;
    wire    [31:0]  gtx3_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx3_tx_data_vio_async_out_i;
    wire    [31:0]  gtx3_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx3_rx_data_vio_async_in_i;
    wire    [31:0]  gtx3_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx3_rx_data_vio_async_out_i;
    wire    [31:0]  gtx3_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx3_ila_in_i;

    wire    [31:0]  gtx4_tx_data_vio_async_in_i;
    wire    [31:0]  gtx4_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx4_tx_data_vio_async_out_i;
    wire    [31:0]  gtx4_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx4_rx_data_vio_async_in_i;
    wire    [31:0]  gtx4_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx4_rx_data_vio_async_out_i;
    wire    [31:0]  gtx4_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx4_ila_in_i;

    wire    [31:0]  gtx5_tx_data_vio_async_in_i;
    wire    [31:0]  gtx5_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx5_tx_data_vio_async_out_i;
    wire    [31:0]  gtx5_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx5_rx_data_vio_async_in_i;
    wire    [31:0]  gtx5_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx5_rx_data_vio_async_out_i;
    wire    [31:0]  gtx5_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx5_ila_in_i;

    wire    [31:0]  gtx6_tx_data_vio_async_in_i;
    wire    [31:0]  gtx6_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx6_tx_data_vio_async_out_i;
    wire    [31:0]  gtx6_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx6_rx_data_vio_async_in_i;
    wire    [31:0]  gtx6_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx6_rx_data_vio_async_out_i;
    wire    [31:0]  gtx6_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx6_ila_in_i;

    wire    [31:0]  gtx7_tx_data_vio_async_in_i;
    wire    [31:0]  gtx7_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx7_tx_data_vio_async_out_i;
    wire    [31:0]  gtx7_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx7_rx_data_vio_async_in_i;
    wire    [31:0]  gtx7_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx7_rx_data_vio_async_out_i;
    wire    [31:0]  gtx7_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx7_ila_in_i;

    wire    [31:0]  gtx8_tx_data_vio_async_in_i;
    wire    [31:0]  gtx8_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx8_tx_data_vio_async_out_i;
    wire    [31:0]  gtx8_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx8_rx_data_vio_async_in_i;
    wire    [31:0]  gtx8_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx8_rx_data_vio_async_out_i;
    wire    [31:0]  gtx8_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx8_ila_in_i;

    wire    [31:0]  gtx9_tx_data_vio_async_in_i;
    wire    [31:0]  gtx9_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx9_tx_data_vio_async_out_i;
    wire    [31:0]  gtx9_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx9_rx_data_vio_async_in_i;
    wire    [31:0]  gtx9_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx9_rx_data_vio_async_out_i;
    wire    [31:0]  gtx9_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx9_ila_in_i;

    wire    [31:0]  gtx10_tx_data_vio_async_in_i;
    wire    [31:0]  gtx10_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx10_tx_data_vio_async_out_i;
    wire    [31:0]  gtx10_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx10_rx_data_vio_async_in_i;
    wire    [31:0]  gtx10_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx10_rx_data_vio_async_out_i;
    wire    [31:0]  gtx10_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx10_ila_in_i;

    wire    [31:0]  gtx11_tx_data_vio_async_in_i;
    wire    [31:0]  gtx11_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx11_tx_data_vio_async_out_i;
    wire    [31:0]  gtx11_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx11_rx_data_vio_async_in_i;
    wire    [31:0]  gtx11_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx11_rx_data_vio_async_out_i;
    wire    [31:0]  gtx11_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx11_ila_in_i;


    wire            gtxtxreset_i;
    wire            gtxrxreset_i;
    wire    [3:0]   mux_sel_i;
    wire    [148:0] gtx0_rx_data_to_fifo_i;
    wire    [148:0] gtx0_rx_data_from_fifo_i;
    wire    [31:0]  gtx0_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx0_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx0_fifo_ila_in_i;
    wire    [148:0] gtx1_rx_data_to_fifo_i;
    wire    [148:0] gtx1_rx_data_from_fifo_i;
    wire    [31:0]  gtx1_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx1_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx1_fifo_ila_in_i;
    wire    [148:0] gtx2_rx_data_to_fifo_i;
    wire    [148:0] gtx2_rx_data_from_fifo_i;
    wire    [31:0]  gtx2_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx2_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx2_fifo_ila_in_i;
    wire    [148:0] gtx3_rx_data_to_fifo_i;
    wire    [148:0] gtx3_rx_data_from_fifo_i;
    wire    [31:0]  gtx3_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx3_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx3_fifo_ila_in_i;
    wire    [148:0] gtx4_rx_data_to_fifo_i;
    wire    [148:0] gtx4_rx_data_from_fifo_i;
    wire    [31:0]  gtx4_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx4_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx4_fifo_ila_in_i;
    wire    [148:0] gtx5_rx_data_to_fifo_i;
    wire    [148:0] gtx5_rx_data_from_fifo_i;
    wire    [31:0]  gtx5_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx5_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx5_fifo_ila_in_i;
    wire    [148:0] gtx6_rx_data_to_fifo_i;
    wire    [148:0] gtx6_rx_data_from_fifo_i;
    wire    [31:0]  gtx6_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx6_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx6_fifo_ila_in_i;
    wire    [148:0] gtx7_rx_data_to_fifo_i;
    wire    [148:0] gtx7_rx_data_from_fifo_i;
    wire    [31:0]  gtx7_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx7_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx7_fifo_ila_in_i;
    wire    [148:0] gtx8_rx_data_to_fifo_i;
    wire    [148:0] gtx8_rx_data_from_fifo_i;
    wire    [31:0]  gtx8_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx8_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx8_fifo_ila_in_i;
    wire    [148:0] gtx9_rx_data_to_fifo_i;
    wire    [148:0] gtx9_rx_data_from_fifo_i;
    wire    [31:0]  gtx9_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx9_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx9_fifo_ila_in_i;
    wire    [148:0] gtx10_rx_data_to_fifo_i;
    wire    [148:0] gtx10_rx_data_from_fifo_i;
    wire    [31:0]  gtx10_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx10_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx10_fifo_ila_in_i;
    wire    [148:0] gtx11_rx_data_to_fifo_i;
    wire    [148:0] gtx11_rx_data_from_fifo_i;
    wire    [31:0]  gtx11_rx_data_fifo_vio_async_in_i;
    wire    [31:0]  gtx11_rx_data_fifo_vio_sync_in_i;
    wire    [84:0]  gtx11_fifo_ila_in_i;

    wire            user_tx_reset_i;
    wire            user_rx_reset_i;
    wire            tx_vio_clk_i;
    wire            tx_vio_clk_mux_out_i;    
    wire            rx_vio_ila_clk_i;
    wire            rx_vio_ila_clk_mux_out_i;

//**************************** Main Body of Code *******************************

    //  Static signal Assigments    
    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 64'h0000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 8'hff;



    //---------------------Dedicated GTX Reference Clock Inputs ---------------
    // The dedicated reference clock inputs you selected in the GUI are implemented using
    // IBUFDS_GTXE1 instances.
    //
    // In the UCF file for this example design, you will see that each of
    // these IBUFDS_GTXE1 instances has been LOCed to a particular set of pins. By LOCing to these
    // locations, we tell the tools to use the dedicated input buffers to the GTX reference
    // clock network, rather than general purpose IOs. To select other pins, consult the 
    // Implementation chapter of UG___, or rerun the wizard.
    //
    // This network is the highest performace (lowest jitter) option for providing clocks
    // to the GTX transceivers.
    
    IBUFDS_GTXE1 q3_clk0_refclk_ibufds_i
    (
        .O                              (q3_clk0_refclk_i),
        .ODIV2                          (),
        .CEB                            (tied_to_ground_i),
        .I                              (Q3_CLK0_MGTREFCLK_PAD_P_IN),
        .IB                             (Q3_CLK0_MGTREFCLK_PAD_N_IN)
    );

 
    




    //--------------------------------- User Clocks ---------------------------
    
    // The clock resources in this section were added based on userclk source selections on
    // the Latency, Buffering, and Clocking page of the GUI. A few notes about user clocks:
    // * The userclk and userclk2 for each GTX datapath (TX and RX) must be phase aligned to 
    //   avoid data errors in the fabric interface whenever the datapath is wider than 10 bits
    // * To minimize clock resources, you can share clocks between GTXs. GTXs using the same frequency
    //   or multiples of the same frequency can be accomadated using MMCMs. Use caution when
    //   using RXRECCLK as a clock source, however - these clocks can typically only be shared if all
    //   the channels using the clock are receiving data from TX channels that share a reference clock 
    //   source with each other.

    BUFG rxrecclk_mmcm0_bufg_i
    (
        .I                              (gtx0_rxrecclk_i),
        .O                              (gtx0_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm0_reset_i               =  !gtx0_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm0_i
    (
        .CLK0_OUT                       (gtx0_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx0_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm0_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm0_reset_i)
    );


    BUFG rxrecclk_mmcm1_bufg_i
    (
        .I                              (gtx1_rxrecclk_i),
        .O                              (gtx1_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm1_reset_i               =  !gtx1_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm1_i
    (
        .CLK0_OUT                       (gtx1_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx1_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm1_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm1_reset_i)
    );


    BUFG rxrecclk_mmcm2_bufg_i
    (
        .I                              (gtx2_rxrecclk_i),
        .O                              (gtx2_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm2_reset_i               =  !gtx2_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm2_i
    (
        .CLK0_OUT                       (gtx2_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx2_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm2_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm2_reset_i)
    );


    BUFG rxrecclk_mmcm3_bufg_i
    (
        .I                              (gtx3_rxrecclk_i),
        .O                              (gtx3_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm3_reset_i               =  !gtx3_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm3_i
    (
        .CLK0_OUT                       (gtx3_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx3_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm3_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm3_reset_i)
    );


    BUFG rxrecclk_mmcm4_bufg_i
    (
        .I                              (gtx4_rxrecclk_i),
        .O                              (gtx4_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm4_reset_i               =  !gtx4_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm4_i
    (
        .CLK0_OUT                       (gtx4_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx4_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm4_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm4_reset_i)
    );


    BUFG rxrecclk_mmcm5_bufg_i
    (
        .I                              (gtx5_rxrecclk_i),
        .O                              (gtx5_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm5_reset_i               =  !gtx5_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm5_i
    (
        .CLK0_OUT                       (gtx5_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx5_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm5_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm5_reset_i)
    );


    BUFG rxrecclk_mmcm6_bufg_i
    (
        .I                              (gtx6_rxrecclk_i),
        .O                              (gtx6_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm6_reset_i               =  !gtx6_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm6_i
    (
        .CLK0_OUT                       (gtx6_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx6_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm6_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm6_reset_i)
    );


    BUFG rxrecclk_mmcm7_bufg_i
    (
        .I                              (gtx7_rxrecclk_i),
        .O                              (gtx7_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm7_reset_i               =  !gtx7_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm7_i
    (
        .CLK0_OUT                       (gtx7_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx7_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm7_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm7_reset_i)
    );


    BUFG rxrecclk_mmcm8_bufg_i
    (
        .I                              (gtx8_rxrecclk_i),
        .O                              (gtx8_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm8_reset_i               =  !gtx8_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm8_i
    (
        .CLK0_OUT                       (gtx8_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx8_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm8_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm8_reset_i)
    );


    BUFG rxrecclk_mmcm9_bufg_i
    (
        .I                              (gtx9_rxrecclk_i),
        .O                              (gtx9_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm9_reset_i               =  !gtx9_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm9_i
    (
        .CLK0_OUT                       (gtx9_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx9_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm9_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm9_reset_i)
    );


    BUFG rxrecclk_mmcm10_bufg_i
    (
        .I                              (gtx10_rxrecclk_i),
        .O                              (gtx10_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm10_reset_i              =  !gtx10_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm10_i
    (
        .CLK0_OUT                       (gtx10_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx10_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm10_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm10_reset_i)
    );


    BUFG rxrecclk_mmcm11_bufg_i
    (
        .I                              (gtx11_rxrecclk_i),
        .O                              (gtx11_rxrecclk_to_mmcm_i)
    );

    assign  rxrecclk_mmcm11_reset_i              =  !gtx11_rxplllkdet_i;
    MGT_USRCLK_SOURCE_MMCM #
    (
        .MULT                           (8.0),
        .DIVIDE                         (2),
        .CLK_PERIOD                     (3.13),
        .OUT0_DIVIDE                    (8.0),
        .OUT1_DIVIDE                    (1),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    rxrecclk_mmcm11_i
    (
        .CLK0_OUT                       (gtx11_rxusrclk2_i),
        .CLK1_OUT                       (),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (gtx11_rxrecclk_to_mmcm_i),
        .MMCM_LOCKED_OUT                (rxrecclk_mmcm11_locked_i),
        .MMCM_RESET_IN                  (rxrecclk_mmcm11_reset_i)
    );






    //--------------------------- The GTX Wrapper -----------------------------
    
    // Use the instantiation template in the example directory to add the GTX wrapper to your design.
    // In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    // checker. The GTXs will reset, then attempt to align and transmit data. If channel bonding is 
    // enabled, bonding should occur after alignment.
    
    MGT_32GBPS_16BIT_1TO12 #
    (
        .WRAPPER_SIM_GTXRESET_SPEEDUP   (EXAMPLE_SIM_GTXRESET_SPEEDUP)
    )
    mgt_32gbps_16bit_1to12_i
    (
 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX0  (X0Y8)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX0_RXPOWERDOWN_IN            (gtx0_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX0_RXCHARISK_OUT             (gtx0_rxcharisk_i),
        .GTX0_RXDISPERR_OUT             (gtx0_rxdisperr_i),
        .GTX0_RXNOTINTABLE_OUT          (gtx0_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX0_RXCLKCORCNT_OUT           (gtx0_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX0_RXENMCOMMAALIGN_IN        (gtx0_rxenmcommaalign_i),
        .GTX0_RXENPCOMMAALIGN_IN        (gtx0_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX0_RXDATA_OUT                (gtx0_rxdata_i),
        .GTX0_RXRECCLK_OUT              (gtx0_rxrecclk_i),
        .GTX0_RXUSRCLK2_IN              (gtx0_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX0_RXN_IN                    (RXN_IN[0]),
        .GTX0_RXP_IN                    (RXP_IN[0]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX0_GTXRXRESET_IN             (gtx0_gtxrxreset_i),
        .GTX0_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX0_PLLRXRESET_IN             (gtx0_pllrxreset_i),
        .GTX0_RXPLLLKDET_OUT            (gtx0_rxplllkdet_i),
        .GTX0_RXRESETDONE_OUT           (gtx0_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX0_TXN_OUT                   (TXN_OUT[0]),
        .GTX0_TXP_OUT                   (TXP_OUT[0]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX1  (X0Y9)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX1_RXPOWERDOWN_IN            (gtx1_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX1_RXCHARISK_OUT             (gtx1_rxcharisk_i),
        .GTX1_RXDISPERR_OUT             (gtx1_rxdisperr_i),
        .GTX1_RXNOTINTABLE_OUT          (gtx1_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX1_RXCLKCORCNT_OUT           (gtx1_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX1_RXENMCOMMAALIGN_IN        (gtx1_rxenmcommaalign_i),
        .GTX1_RXENPCOMMAALIGN_IN        (gtx1_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX1_RXDATA_OUT                (gtx1_rxdata_i),
        .GTX1_RXRECCLK_OUT              (gtx1_rxrecclk_i),
        .GTX1_RXUSRCLK2_IN              (gtx1_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX1_RXN_IN                    (RXN_IN[1]),
        .GTX1_RXP_IN                    (RXP_IN[1]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX1_GTXRXRESET_IN             (gtx1_gtxrxreset_i),
        .GTX1_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX1_PLLRXRESET_IN             (gtx1_pllrxreset_i),
        .GTX1_RXPLLLKDET_OUT            (gtx1_rxplllkdet_i),
        .GTX1_RXRESETDONE_OUT           (gtx1_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX1_TXN_OUT                   (TXN_OUT[1]),
        .GTX1_TXP_OUT                   (TXP_OUT[1]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX2  (X0Y10)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX2_RXPOWERDOWN_IN            (gtx2_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX2_RXCHARISK_OUT             (gtx2_rxcharisk_i),
        .GTX2_RXDISPERR_OUT             (gtx2_rxdisperr_i),
        .GTX2_RXNOTINTABLE_OUT          (gtx2_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX2_RXCLKCORCNT_OUT           (gtx2_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX2_RXENMCOMMAALIGN_IN        (gtx2_rxenmcommaalign_i),
        .GTX2_RXENPCOMMAALIGN_IN        (gtx2_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX2_RXDATA_OUT                (gtx2_rxdata_i),
        .GTX2_RXRECCLK_OUT              (gtx2_rxrecclk_i),
        .GTX2_RXUSRCLK2_IN              (gtx2_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX2_RXN_IN                    (RXN_IN[2]),
        .GTX2_RXP_IN                    (RXP_IN[2]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX2_GTXRXRESET_IN             (gtx2_gtxrxreset_i),
        .GTX2_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX2_PLLRXRESET_IN             (gtx2_pllrxreset_i),
        .GTX2_RXPLLLKDET_OUT            (gtx2_rxplllkdet_i),
        .GTX2_RXRESETDONE_OUT           (gtx2_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX2_TXN_OUT                   (TXN_OUT[2]),
        .GTX2_TXP_OUT                   (TXP_OUT[2]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX3  (X0Y11)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX3_RXPOWERDOWN_IN            (gtx3_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX3_RXCHARISK_OUT             (gtx3_rxcharisk_i),
        .GTX3_RXDISPERR_OUT             (gtx3_rxdisperr_i),
        .GTX3_RXNOTINTABLE_OUT          (gtx3_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX3_RXCLKCORCNT_OUT           (gtx3_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX3_RXENMCOMMAALIGN_IN        (gtx3_rxenmcommaalign_i),
        .GTX3_RXENPCOMMAALIGN_IN        (gtx3_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX3_RXDATA_OUT                (gtx3_rxdata_i),
        .GTX3_RXRECCLK_OUT              (gtx3_rxrecclk_i),
        .GTX3_RXUSRCLK2_IN              (gtx3_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX3_RXN_IN                    (RXN_IN[3]),
        .GTX3_RXP_IN                    (RXP_IN[3]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX3_GTXRXRESET_IN             (gtx3_gtxrxreset_i),
        .GTX3_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX3_PLLRXRESET_IN             (gtx3_pllrxreset_i),
        .GTX3_RXPLLLKDET_OUT            (gtx3_rxplllkdet_i),
        .GTX3_RXRESETDONE_OUT           (gtx3_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX3_TXN_OUT                   (TXN_OUT[3]),
        .GTX3_TXP_OUT                   (TXP_OUT[3]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX4  (X0Y12)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX4_RXPOWERDOWN_IN            (gtx4_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX4_RXCHARISK_OUT             (gtx4_rxcharisk_i),
        .GTX4_RXDISPERR_OUT             (gtx4_rxdisperr_i),
        .GTX4_RXNOTINTABLE_OUT          (gtx4_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX4_RXCLKCORCNT_OUT           (gtx4_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX4_RXENMCOMMAALIGN_IN        (gtx4_rxenmcommaalign_i),
        .GTX4_RXENPCOMMAALIGN_IN        (gtx4_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX4_RXDATA_OUT                (gtx4_rxdata_i),
        .GTX4_RXRECCLK_OUT              (gtx4_rxrecclk_i),
        .GTX4_RXUSRCLK2_IN              (gtx4_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX4_RXN_IN                    (RXN_IN[4]),
        .GTX4_RXP_IN                    (RXP_IN[4]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX4_GTXRXRESET_IN             (gtx4_gtxrxreset_i),
        .GTX4_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX4_PLLRXRESET_IN             (gtx4_pllrxreset_i),
        .GTX4_RXPLLLKDET_OUT            (gtx4_rxplllkdet_i),
        .GTX4_RXRESETDONE_OUT           (gtx4_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX4_TXN_OUT                   (TXN_OUT[4]),
        .GTX4_TXP_OUT                   (TXP_OUT[4]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX5  (X0Y13)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX5_RXPOWERDOWN_IN            (gtx5_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX5_RXCHARISK_OUT             (gtx5_rxcharisk_i),
        .GTX5_RXDISPERR_OUT             (gtx5_rxdisperr_i),
        .GTX5_RXNOTINTABLE_OUT          (gtx5_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX5_RXCLKCORCNT_OUT           (gtx5_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX5_RXENMCOMMAALIGN_IN        (gtx5_rxenmcommaalign_i),
        .GTX5_RXENPCOMMAALIGN_IN        (gtx5_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX5_RXDATA_OUT                (gtx5_rxdata_i),
        .GTX5_RXRECCLK_OUT              (gtx5_rxrecclk_i),
        .GTX5_RXUSRCLK2_IN              (gtx5_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX5_RXN_IN                    (RXN_IN[5]),
        .GTX5_RXP_IN                    (RXP_IN[5]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX5_GTXRXRESET_IN             (gtx5_gtxrxreset_i),
        .GTX5_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX5_PLLRXRESET_IN             (gtx5_pllrxreset_i),
        .GTX5_RXPLLLKDET_OUT            (gtx5_rxplllkdet_i),
        .GTX5_RXRESETDONE_OUT           (gtx5_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX5_TXN_OUT                   (TXN_OUT[5]),
        .GTX5_TXP_OUT                   (TXP_OUT[5]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX6  (X0Y14)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX6_RXPOWERDOWN_IN            (gtx6_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX6_RXCHARISK_OUT             (gtx6_rxcharisk_i),
        .GTX6_RXDISPERR_OUT             (gtx6_rxdisperr_i),
        .GTX6_RXNOTINTABLE_OUT          (gtx6_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX6_RXCLKCORCNT_OUT           (gtx6_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX6_RXENMCOMMAALIGN_IN        (gtx6_rxenmcommaalign_i),
        .GTX6_RXENPCOMMAALIGN_IN        (gtx6_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX6_RXDATA_OUT                (gtx6_rxdata_i),
        .GTX6_RXRECCLK_OUT              (gtx6_rxrecclk_i),
        .GTX6_RXUSRCLK2_IN              (gtx6_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX6_RXN_IN                    (RXN_IN[6]),
        .GTX6_RXP_IN                    (RXP_IN[6]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX6_GTXRXRESET_IN             (gtx6_gtxrxreset_i),
        .GTX6_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX6_PLLRXRESET_IN             (gtx6_pllrxreset_i),
        .GTX6_RXPLLLKDET_OUT            (gtx6_rxplllkdet_i),
        .GTX6_RXRESETDONE_OUT           (gtx6_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX6_TXN_OUT                   (TXN_OUT[6]),
        .GTX6_TXP_OUT                   (TXP_OUT[6]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX7  (X0Y15)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX7_RXPOWERDOWN_IN            (gtx7_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX7_RXCHARISK_OUT             (gtx7_rxcharisk_i),
        .GTX7_RXDISPERR_OUT             (gtx7_rxdisperr_i),
        .GTX7_RXNOTINTABLE_OUT          (gtx7_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX7_RXCLKCORCNT_OUT           (gtx7_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX7_RXENMCOMMAALIGN_IN        (gtx7_rxenmcommaalign_i),
        .GTX7_RXENPCOMMAALIGN_IN        (gtx7_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX7_RXDATA_OUT                (gtx7_rxdata_i),
        .GTX7_RXRECCLK_OUT              (gtx7_rxrecclk_i),
        .GTX7_RXUSRCLK2_IN              (gtx7_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX7_RXN_IN                    (RXN_IN[7]),
        .GTX7_RXP_IN                    (RXP_IN[7]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX7_GTXRXRESET_IN             (gtx7_gtxrxreset_i),
        .GTX7_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX7_PLLRXRESET_IN             (gtx7_pllrxreset_i),
        .GTX7_RXPLLLKDET_OUT            (gtx7_rxplllkdet_i),
        .GTX7_RXRESETDONE_OUT           (gtx7_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX7_TXN_OUT                   (TXN_OUT[7]),
        .GTX7_TXP_OUT                   (TXP_OUT[7]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX8  (X0Y16)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX8_RXPOWERDOWN_IN            (gtx8_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX8_RXCHARISK_OUT             (gtx8_rxcharisk_i),
        .GTX8_RXDISPERR_OUT             (gtx8_rxdisperr_i),
        .GTX8_RXNOTINTABLE_OUT          (gtx8_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX8_RXCLKCORCNT_OUT           (gtx8_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX8_RXENMCOMMAALIGN_IN        (gtx8_rxenmcommaalign_i),
        .GTX8_RXENPCOMMAALIGN_IN        (gtx8_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX8_RXDATA_OUT                (gtx8_rxdata_i),
        .GTX8_RXRECCLK_OUT              (gtx8_rxrecclk_i),
        .GTX8_RXUSRCLK2_IN              (gtx8_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX8_RXN_IN                    (RXN_IN[8]),
        .GTX8_RXP_IN                    (RXP_IN[8]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX8_GTXRXRESET_IN             (gtx8_gtxrxreset_i),
        .GTX8_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX8_PLLRXRESET_IN             (gtx8_pllrxreset_i),
        .GTX8_RXPLLLKDET_OUT            (gtx8_rxplllkdet_i),
        .GTX8_RXRESETDONE_OUT           (gtx8_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX8_TXN_OUT                   (TXN_OUT[8]),
        .GTX8_TXP_OUT                   (TXP_OUT[8]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX9  (X0Y17)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX9_RXPOWERDOWN_IN            (gtx9_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX9_RXCHARISK_OUT             (gtx9_rxcharisk_i),
        .GTX9_RXDISPERR_OUT             (gtx9_rxdisperr_i),
        .GTX9_RXNOTINTABLE_OUT          (gtx9_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX9_RXCLKCORCNT_OUT           (gtx9_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX9_RXENMCOMMAALIGN_IN        (gtx9_rxenmcommaalign_i),
        .GTX9_RXENPCOMMAALIGN_IN        (gtx9_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX9_RXDATA_OUT                (gtx9_rxdata_i),
        .GTX9_RXRECCLK_OUT              (gtx9_rxrecclk_i),
        .GTX9_RXUSRCLK2_IN              (gtx9_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX9_RXN_IN                    (RXN_IN[9]),
        .GTX9_RXP_IN                    (RXP_IN[9]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX9_GTXRXRESET_IN             (gtx9_gtxrxreset_i),
        .GTX9_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX9_PLLRXRESET_IN             (gtx9_pllrxreset_i),
        .GTX9_RXPLLLKDET_OUT            (gtx9_rxplllkdet_i),
        .GTX9_RXRESETDONE_OUT           (gtx9_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX9_TXN_OUT                   (TXN_OUT[9]),
        .GTX9_TXP_OUT                   (TXP_OUT[9]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX10  (X0Y18)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX10_RXPOWERDOWN_IN           (gtx10_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX10_RXCHARISK_OUT            (gtx10_rxcharisk_i),
        .GTX10_RXDISPERR_OUT            (gtx10_rxdisperr_i),
        .GTX10_RXNOTINTABLE_OUT         (gtx10_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX10_RXCLKCORCNT_OUT          (gtx10_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX10_RXENMCOMMAALIGN_IN       (gtx10_rxenmcommaalign_i),
        .GTX10_RXENPCOMMAALIGN_IN       (gtx10_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX10_RXDATA_OUT               (gtx10_rxdata_i),
        .GTX10_RXRECCLK_OUT             (gtx10_rxrecclk_i),
        .GTX10_RXUSRCLK2_IN             (gtx10_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX10_RXN_IN                   (RXN_IN[10]),
        .GTX10_RXP_IN                   (RXP_IN[10]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX10_GTXRXRESET_IN            (gtx10_gtxrxreset_i),
        .GTX10_MGTREFCLKRX_IN           (q3_clk0_refclk_i),
        .GTX10_PLLRXRESET_IN            (gtx10_pllrxreset_i),
        .GTX10_RXPLLLKDET_OUT           (gtx10_rxplllkdet_i),
        .GTX10_RXRESETDONE_OUT          (gtx10_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX10_TXN_OUT                  (TXN_OUT[10]),
        .GTX10_TXP_OUT                  (TXP_OUT[10]),


 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX11  (X0Y19)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX11_RXPOWERDOWN_IN           (gtx11_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX11_RXCHARISK_OUT            (gtx11_rxcharisk_i),
        .GTX11_RXDISPERR_OUT            (gtx11_rxdisperr_i),
        .GTX11_RXNOTINTABLE_OUT         (gtx11_rxnotintable_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX11_RXCLKCORCNT_OUT          (gtx11_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX11_RXENMCOMMAALIGN_IN       (gtx11_rxenmcommaalign_i),
        .GTX11_RXENPCOMMAALIGN_IN       (gtx11_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX11_RXDATA_OUT               (gtx11_rxdata_i),
        .GTX11_RXRECCLK_OUT             (gtx11_rxrecclk_i),
        .GTX11_RXUSRCLK2_IN             (gtx11_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX11_RXN_IN                   (RXN_IN[11]),
        .GTX11_RXP_IN                   (RXP_IN[11]),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX11_GTXRXRESET_IN            (gtx11_gtxrxreset_i),
        .GTX11_MGTREFCLKRX_IN           (q3_clk0_refclk_i),
        .GTX11_PLLRXRESET_IN            (gtx11_pllrxreset_i),
        .GTX11_RXPLLLKDET_OUT           (gtx11_rxplllkdet_i),
        .GTX11_RXRESETDONE_OUT          (gtx11_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX11_TXN_OUT                  (TXN_OUT[11]),
        .GTX11_TXP_OUT                  (TXP_OUT[11])


    );



    //------------------------ User Module Resets -----------------------------
    // All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    // are held in reset till the RESETDONE goes high. 
    // The RESETDONE is registered a couple of times on *USRCLK2 and connected 
    // to the reset of the modules
    

    always @(posedge gtx0_rxusrclk2_i)
            gtx0_rxresetdone_i_r   <=   `DLY gtx0_rxresetdone_i;

    always @(posedge gtx0_rxusrclk2_i or negedge gtx0_rxresetdone_i_r)

    begin
        if (!gtx0_rxresetdone_i_r)
        begin
            gtx0_rxresetdone_r      <=   `DLY 1'b0;
            gtx0_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx0_rxresetdone_r      <=   `DLY gtx0_rxresetdone_i_r;
            gtx0_rxresetdone_r2     <=   `DLY gtx0_rxresetdone_r;
        end
    end

    always @(posedge gtx0_rxusrclk2_i)
            gtx0_rxresetdone_r3   <=   `DLY gtx0_rxresetdone_r2;
    

    always @(posedge gtx1_rxusrclk2_i)
            gtx1_rxresetdone_i_r   <=   `DLY gtx1_rxresetdone_i;

    always @(posedge gtx1_rxusrclk2_i or negedge gtx1_rxresetdone_i_r)

    begin
        if (!gtx1_rxresetdone_i_r)
        begin
            gtx1_rxresetdone_r      <=   `DLY 1'b0;
            gtx1_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx1_rxresetdone_r      <=   `DLY gtx1_rxresetdone_i_r;
            gtx1_rxresetdone_r2     <=   `DLY gtx1_rxresetdone_r;
        end
    end

    always @(posedge gtx1_rxusrclk2_i)
            gtx1_rxresetdone_r3   <=   `DLY gtx1_rxresetdone_r2;
    

    always @(posedge gtx2_rxusrclk2_i)
            gtx2_rxresetdone_i_r   <=   `DLY gtx2_rxresetdone_i;

    always @(posedge gtx2_rxusrclk2_i or negedge gtx2_rxresetdone_i_r)

    begin
        if (!gtx2_rxresetdone_i_r)
        begin
            gtx2_rxresetdone_r      <=   `DLY 1'b0;
            gtx2_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx2_rxresetdone_r      <=   `DLY gtx2_rxresetdone_i_r;
            gtx2_rxresetdone_r2     <=   `DLY gtx2_rxresetdone_r;
        end
    end

    always @(posedge gtx2_rxusrclk2_i)
            gtx2_rxresetdone_r3   <=   `DLY gtx2_rxresetdone_r2;
    

    always @(posedge gtx3_rxusrclk2_i)
            gtx3_rxresetdone_i_r   <=   `DLY gtx3_rxresetdone_i;

    always @(posedge gtx3_rxusrclk2_i or negedge gtx3_rxresetdone_i_r)

    begin
        if (!gtx3_rxresetdone_i_r)
        begin
            gtx3_rxresetdone_r      <=   `DLY 1'b0;
            gtx3_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx3_rxresetdone_r      <=   `DLY gtx3_rxresetdone_i_r;
            gtx3_rxresetdone_r2     <=   `DLY gtx3_rxresetdone_r;
        end
    end

    always @(posedge gtx3_rxusrclk2_i)
            gtx3_rxresetdone_r3   <=   `DLY gtx3_rxresetdone_r2;
    

    always @(posedge gtx4_rxusrclk2_i)
            gtx4_rxresetdone_i_r   <=   `DLY gtx4_rxresetdone_i;

    always @(posedge gtx4_rxusrclk2_i or negedge gtx4_rxresetdone_i_r)

    begin
        if (!gtx4_rxresetdone_i_r)
        begin
            gtx4_rxresetdone_r      <=   `DLY 1'b0;
            gtx4_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx4_rxresetdone_r      <=   `DLY gtx4_rxresetdone_i_r;
            gtx4_rxresetdone_r2     <=   `DLY gtx4_rxresetdone_r;
        end
    end

    always @(posedge gtx4_rxusrclk2_i)
            gtx4_rxresetdone_r3   <=   `DLY gtx4_rxresetdone_r2;
    

    always @(posedge gtx5_rxusrclk2_i)
            gtx5_rxresetdone_i_r   <=   `DLY gtx5_rxresetdone_i;

    always @(posedge gtx5_rxusrclk2_i or negedge gtx5_rxresetdone_i_r)

    begin
        if (!gtx5_rxresetdone_i_r)
        begin
            gtx5_rxresetdone_r      <=   `DLY 1'b0;
            gtx5_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx5_rxresetdone_r      <=   `DLY gtx5_rxresetdone_i_r;
            gtx5_rxresetdone_r2     <=   `DLY gtx5_rxresetdone_r;
        end
    end

    always @(posedge gtx5_rxusrclk2_i)
            gtx5_rxresetdone_r3   <=   `DLY gtx5_rxresetdone_r2;
    

    always @(posedge gtx6_rxusrclk2_i)
            gtx6_rxresetdone_i_r   <=   `DLY gtx6_rxresetdone_i;

    always @(posedge gtx6_rxusrclk2_i or negedge gtx6_rxresetdone_i_r)

    begin
        if (!gtx6_rxresetdone_i_r)
        begin
            gtx6_rxresetdone_r      <=   `DLY 1'b0;
            gtx6_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx6_rxresetdone_r      <=   `DLY gtx6_rxresetdone_i_r;
            gtx6_rxresetdone_r2     <=   `DLY gtx6_rxresetdone_r;
        end
    end

    always @(posedge gtx6_rxusrclk2_i)
            gtx6_rxresetdone_r3   <=   `DLY gtx6_rxresetdone_r2;
    

    always @(posedge gtx7_rxusrclk2_i)
            gtx7_rxresetdone_i_r   <=   `DLY gtx7_rxresetdone_i;

    always @(posedge gtx7_rxusrclk2_i or negedge gtx7_rxresetdone_i_r)

    begin
        if (!gtx7_rxresetdone_i_r)
        begin
            gtx7_rxresetdone_r      <=   `DLY 1'b0;
            gtx7_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx7_rxresetdone_r      <=   `DLY gtx7_rxresetdone_i_r;
            gtx7_rxresetdone_r2     <=   `DLY gtx7_rxresetdone_r;
        end
    end

    always @(posedge gtx7_rxusrclk2_i)
            gtx7_rxresetdone_r3   <=   `DLY gtx7_rxresetdone_r2;
    

    always @(posedge gtx8_rxusrclk2_i)
            gtx8_rxresetdone_i_r   <=   `DLY gtx8_rxresetdone_i;

    always @(posedge gtx8_rxusrclk2_i or negedge gtx8_rxresetdone_i_r)

    begin
        if (!gtx8_rxresetdone_i_r)
        begin
            gtx8_rxresetdone_r      <=   `DLY 1'b0;
            gtx8_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx8_rxresetdone_r      <=   `DLY gtx8_rxresetdone_i_r;
            gtx8_rxresetdone_r2     <=   `DLY gtx8_rxresetdone_r;
        end
    end

    always @(posedge gtx8_rxusrclk2_i)
            gtx8_rxresetdone_r3   <=   `DLY gtx8_rxresetdone_r2;
    

    always @(posedge gtx9_rxusrclk2_i)
            gtx9_rxresetdone_i_r   <=   `DLY gtx9_rxresetdone_i;

    always @(posedge gtx9_rxusrclk2_i or negedge gtx9_rxresetdone_i_r)

    begin
        if (!gtx9_rxresetdone_i_r)
        begin
            gtx9_rxresetdone_r      <=   `DLY 1'b0;
            gtx9_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx9_rxresetdone_r      <=   `DLY gtx9_rxresetdone_i_r;
            gtx9_rxresetdone_r2     <=   `DLY gtx9_rxresetdone_r;
        end
    end

    always @(posedge gtx9_rxusrclk2_i)
            gtx9_rxresetdone_r3   <=   `DLY gtx9_rxresetdone_r2;
    

    always @(posedge gtx10_rxusrclk2_i)
            gtx10_rxresetdone_i_r   <=   `DLY gtx10_rxresetdone_i;

    always @(posedge gtx10_rxusrclk2_i or negedge gtx10_rxresetdone_i_r)

    begin
        if (!gtx10_rxresetdone_i_r)
        begin
            gtx10_rxresetdone_r      <=   `DLY 1'b0;
            gtx10_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx10_rxresetdone_r      <=   `DLY gtx10_rxresetdone_i_r;
            gtx10_rxresetdone_r2     <=   `DLY gtx10_rxresetdone_r;
        end
    end

    always @(posedge gtx10_rxusrclk2_i)
            gtx10_rxresetdone_r3   <=   `DLY gtx10_rxresetdone_r2;
    

    always @(posedge gtx11_rxusrclk2_i)
            gtx11_rxresetdone_i_r   <=   `DLY gtx11_rxresetdone_i;

    always @(posedge gtx11_rxusrclk2_i or negedge gtx11_rxresetdone_i_r)

    begin
        if (!gtx11_rxresetdone_i_r)
        begin
            gtx11_rxresetdone_r      <=   `DLY 1'b0;
            gtx11_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx11_rxresetdone_r      <=   `DLY gtx11_rxresetdone_i_r;
            gtx11_rxresetdone_r2     <=   `DLY gtx11_rxresetdone_r;
        end
    end

    always @(posedge gtx11_rxusrclk2_i)
            gtx11_rxresetdone_r3   <=   `DLY gtx11_rxresetdone_r2;
    




    //-------------------------------- Frame Checkers -------------------------
    // The example design uses Block RAM based frame checkers to verify incoming  
    // data. By default the frame generators are loaded with a data sequence that 
    // matches the outgoing sequence of the frame generators for the TX ports.
    
    // You can modify the expected data sequence by changing the INIT values of the frame
    // checkers in this file. Pay careful attention to bit order and the spacing
    // of your control and alignment characters.
    
    // When the frame checker receives data, it attempts to synchronise to the 
    // incoming pattern by looking for the first sequence in the pattern. Once it 
    // finds the first sequence, it increments through the sequence, and indicates an 
    // error whenever the next value received does not match the expected value.


    assign gtx0_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx0_matchn_i;

    // gtx0_frame_check0 is always connected to the lane with the start of char
    // and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    assign gtx0_inc_in_i = 1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(1),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx0_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx0_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx0_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx0_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx0_inc_in_i),
        .INC_OUT                        (gtx0_inc_out_i),
        .PATTERN_MATCH_N                (gtx0_matchn_i),
        .RESET_ON_ERROR                 (gtx0_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx0_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx0_rx_system_reset_c),
        .ERROR_COUNT                    (gtx0_error_count_i),
        .TRACK_DATA                     (gtx0_track_data_i)

    );

    

    assign gtx1_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx1_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx1_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx1_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx1_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx1_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx1_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx1_inc_in_i),
        .INC_OUT                        (gtx1_inc_out_i),
        .PATTERN_MATCH_N                (gtx1_matchn_i),
        .RESET_ON_ERROR                 (gtx1_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx1_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx1_rx_system_reset_c),
        .ERROR_COUNT                    (gtx1_error_count_i),
        .TRACK_DATA                     (gtx1_track_data_i)

    );

    

    assign gtx2_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx2_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx2_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx2_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx2_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx2_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx2_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx2_inc_in_i),
        .INC_OUT                        (gtx2_inc_out_i),
        .PATTERN_MATCH_N                (gtx2_matchn_i),
        .RESET_ON_ERROR                 (gtx2_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx2_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx2_rx_system_reset_c),
        .ERROR_COUNT                    (gtx2_error_count_i),
        .TRACK_DATA                     (gtx2_track_data_i)

    );

    

    assign gtx3_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx3_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx3_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx3_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx3_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx3_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx3_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx3_inc_in_i),
        .INC_OUT                        (gtx3_inc_out_i),
        .PATTERN_MATCH_N                (gtx3_matchn_i),
        .RESET_ON_ERROR                 (gtx3_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx3_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx3_rx_system_reset_c),
        .ERROR_COUNT                    (gtx3_error_count_i),
        .TRACK_DATA                     (gtx3_track_data_i)

    );

    

    assign gtx4_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx4_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx4_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx4_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx4_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx4_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx4_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx4_inc_in_i),
        .INC_OUT                        (gtx4_inc_out_i),
        .PATTERN_MATCH_N                (gtx4_matchn_i),
        .RESET_ON_ERROR                 (gtx4_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx4_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx4_rx_system_reset_c),
        .ERROR_COUNT                    (gtx4_error_count_i),
        .TRACK_DATA                     (gtx4_track_data_i)

    );

    

    assign gtx5_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx5_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx5_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx5_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx5_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx5_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx5_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx5_inc_in_i),
        .INC_OUT                        (gtx5_inc_out_i),
        .PATTERN_MATCH_N                (gtx5_matchn_i),
        .RESET_ON_ERROR                 (gtx5_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx5_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx5_rx_system_reset_c),
        .ERROR_COUNT                    (gtx5_error_count_i),
        .TRACK_DATA                     (gtx5_track_data_i)

    );

    

    assign gtx6_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx6_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx6_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx6_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx6_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx6_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx6_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx6_inc_in_i),
        .INC_OUT                        (gtx6_inc_out_i),
        .PATTERN_MATCH_N                (gtx6_matchn_i),
        .RESET_ON_ERROR                 (gtx6_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx6_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx6_rx_system_reset_c),
        .ERROR_COUNT                    (gtx6_error_count_i),
        .TRACK_DATA                     (gtx6_track_data_i)

    );

    

    assign gtx7_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx7_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx7_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx7_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx7_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx7_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx7_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx7_inc_in_i),
        .INC_OUT                        (gtx7_inc_out_i),
        .PATTERN_MATCH_N                (gtx7_matchn_i),
        .RESET_ON_ERROR                 (gtx7_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx7_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx7_rx_system_reset_c),
        .ERROR_COUNT                    (gtx7_error_count_i),
        .TRACK_DATA                     (gtx7_track_data_i)

    );

    

    assign gtx8_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx8_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx8_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx8_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx8_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx8_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx8_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx8_inc_in_i),
        .INC_OUT                        (gtx8_inc_out_i),
        .PATTERN_MATCH_N                (gtx8_matchn_i),
        .RESET_ON_ERROR                 (gtx8_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx8_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx8_rx_system_reset_c),
        .ERROR_COUNT                    (gtx8_error_count_i),
        .TRACK_DATA                     (gtx8_track_data_i)

    );

    

    assign gtx9_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx9_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx9_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx9_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx9_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx9_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx9_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx9_inc_in_i),
        .INC_OUT                        (gtx9_inc_out_i),
        .PATTERN_MATCH_N                (gtx9_matchn_i),
        .RESET_ON_ERROR                 (gtx9_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx9_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx9_rx_system_reset_c),
        .ERROR_COUNT                    (gtx9_error_count_i),
        .TRACK_DATA                     (gtx9_track_data_i)

    );

    

    assign gtx10_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx10_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx10_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx10_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx10_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx10_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx10_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx10_inc_in_i),
        .INC_OUT                        (gtx10_inc_out_i),
        .PATTERN_MATCH_N                (gtx10_matchn_i),
        .RESET_ON_ERROR                 (gtx10_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx10_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx10_rx_system_reset_c),
        .ERROR_COUNT                    (gtx10_error_count_i),
        .TRACK_DATA                     (gtx10_track_data_i)

    );

    

    assign gtx11_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx11_matchn_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign gtx11_inc_in_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?gtx0_inc_out_i:1'b0;

 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    gtx11_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx11_rxdata_i),
        .RX_ENMCOMMA_ALIGN              (gtx11_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx11_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx11_inc_in_i),
        .INC_OUT                        (gtx11_inc_out_i),
        .PATTERN_MATCH_N                (gtx11_matchn_i),
        .RESET_ON_ERROR                 (gtx11_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx11_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx11_rx_system_reset_c),
        .ERROR_COUNT                    (gtx11_error_count_i),
        .TRACK_DATA                     (gtx11_track_data_i)

    );

    



    assign TRACK_DATA_OUT = track_data_out_i;

    assign track_data_out_i = 
                                gtx0_track_data_i &
                                gtx1_track_data_i &
                                gtx2_track_data_i &
                                gtx3_track_data_i &
                                gtx4_track_data_i &
                                gtx5_track_data_i &
                                gtx6_track_data_i &
                                gtx7_track_data_i &
                                gtx8_track_data_i &
                                gtx9_track_data_i &
                                gtx10_track_data_i &
                                gtx11_track_data_i ;





    //--------------------------- Chipscope Connections -----------------------
    // When the example design is run in hardware, it uses chipscope to allow the
    // example design and GTX wrapper to be controlled and monitored. The 
    // EXAMPLE_USE_CHIPSCOPE parameter allows chipscope to be removed for simulation.
    
generate
if (EXAMPLE_USE_CHIPSCOPE==1) 
begin : chipscope

    // Shared VIO for all GTXs
    data_vio shared_vio_i
    (
      .control                          (shared_vio_control_i),
      .async_in                         (shared_vio_in_i),
      .async_out                        (shared_vio_out_i),
      .sync_in                          (tied_to_ground_vec_i[31:0]),
      .sync_out                         (),
      .clk                              (tied_to_ground_i)
    );

    // ICON for all VIOs
    icon i_icon
    (
      .control0                         (shared_vio_control_i),
      .control1                         (tx_data_vio_control_i),
      .control2                         (rx_data_vio_control_i),
      .control3                         (ila_control_i)
    );


    // TX VIO
    data_vio tx_data_vio_i
    (
      .control                          (tx_data_vio_control_i),
      .async_in                         (tx_data_vio_async_in_i),
      .async_out                        (tx_data_vio_async_out_i),
      .sync_in                          (tx_data_vio_sync_in_i),
      .sync_out                         (tx_data_vio_sync_out_i),
      .clk                              (rx_vio_ila_clk_i)
    );
    
    // RX VIO
    data_vio rx_data_vio_i
    (
      .control                          (rx_data_vio_control_i),
      .async_in                         (rx_data_vio_async_in_i),
      .async_out                        (rx_data_vio_async_out_i),
      .sync_in                          (rx_data_vio_sync_in_i),
      .sync_out                         (rx_data_vio_sync_out_i),
      .clk                              (rx_vio_ila_clk_i)
    );
    
    // RX ILA
    ila ila_i
    (
      .control                          (ila_control_i),
      .clk                              (rx_vio_ila_clk_i),
      .trig0                            (ila_in_i)
    );



    // The RX VIO and ILA uses GTX0's RXUSRCLK2
    assign  rx_vio_ila_clk_i = gtx0_rxusrclk2_i;

 
    assign gtx0_rx_data_to_fifo_i={gtx0_rx_data_vio_async_in_i,gtx0_rx_data_vio_sync_in_i,gtx0_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_0_i 
    (
	.rst(gtx0_rx_system_reset_c),
	.wr_clk(gtx0_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx0_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx0_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx0_rx_data_fifo_vio_async_in_i = gtx0_rx_data_from_fifo_i[148:117];

    assign gtx0_rx_data_fifo_vio_sync_in_i = gtx0_rx_data_from_fifo_i[116:85];

    assign gtx0_fifo_ila_in_i = gtx0_rx_data_from_fifo_i[84:0];

 
    assign gtx1_rx_data_to_fifo_i={gtx1_rx_data_vio_async_in_i,gtx1_rx_data_vio_sync_in_i,gtx1_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_1_i 
    (
	.rst(gtx1_rx_system_reset_c),
	.wr_clk(gtx1_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx1_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx1_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx1_rx_data_fifo_vio_async_in_i = gtx1_rx_data_from_fifo_i[148:117];

    assign gtx1_rx_data_fifo_vio_sync_in_i = gtx1_rx_data_from_fifo_i[116:85];

    assign gtx1_fifo_ila_in_i = gtx1_rx_data_from_fifo_i[84:0];

 
    assign gtx2_rx_data_to_fifo_i={gtx2_rx_data_vio_async_in_i,gtx2_rx_data_vio_sync_in_i,gtx2_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_2_i 
    (
	.rst(gtx2_rx_system_reset_c),
	.wr_clk(gtx2_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx2_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx2_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx2_rx_data_fifo_vio_async_in_i = gtx2_rx_data_from_fifo_i[148:117];

    assign gtx2_rx_data_fifo_vio_sync_in_i = gtx2_rx_data_from_fifo_i[116:85];

    assign gtx2_fifo_ila_in_i = gtx2_rx_data_from_fifo_i[84:0];

 
    assign gtx3_rx_data_to_fifo_i={gtx3_rx_data_vio_async_in_i,gtx3_rx_data_vio_sync_in_i,gtx3_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_3_i 
    (
	.rst(gtx3_rx_system_reset_c),
	.wr_clk(gtx3_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx3_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx3_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx3_rx_data_fifo_vio_async_in_i = gtx3_rx_data_from_fifo_i[148:117];

    assign gtx3_rx_data_fifo_vio_sync_in_i = gtx3_rx_data_from_fifo_i[116:85];

    assign gtx3_fifo_ila_in_i = gtx3_rx_data_from_fifo_i[84:0];

 
    assign gtx4_rx_data_to_fifo_i={gtx4_rx_data_vio_async_in_i,gtx4_rx_data_vio_sync_in_i,gtx4_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_4_i 
    (
	.rst(gtx4_rx_system_reset_c),
	.wr_clk(gtx4_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx4_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx4_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx4_rx_data_fifo_vio_async_in_i = gtx4_rx_data_from_fifo_i[148:117];

    assign gtx4_rx_data_fifo_vio_sync_in_i = gtx4_rx_data_from_fifo_i[116:85];

    assign gtx4_fifo_ila_in_i = gtx4_rx_data_from_fifo_i[84:0];

 
    assign gtx5_rx_data_to_fifo_i={gtx5_rx_data_vio_async_in_i,gtx5_rx_data_vio_sync_in_i,gtx5_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_5_i 
    (
	.rst(gtx5_rx_system_reset_c),
	.wr_clk(gtx5_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx5_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx5_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx5_rx_data_fifo_vio_async_in_i = gtx5_rx_data_from_fifo_i[148:117];

    assign gtx5_rx_data_fifo_vio_sync_in_i = gtx5_rx_data_from_fifo_i[116:85];

    assign gtx5_fifo_ila_in_i = gtx5_rx_data_from_fifo_i[84:0];

 
    assign gtx6_rx_data_to_fifo_i={gtx6_rx_data_vio_async_in_i,gtx6_rx_data_vio_sync_in_i,gtx6_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_6_i 
    (
	.rst(gtx6_rx_system_reset_c),
	.wr_clk(gtx6_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx6_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx6_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx6_rx_data_fifo_vio_async_in_i = gtx6_rx_data_from_fifo_i[148:117];

    assign gtx6_rx_data_fifo_vio_sync_in_i = gtx6_rx_data_from_fifo_i[116:85];

    assign gtx6_fifo_ila_in_i = gtx6_rx_data_from_fifo_i[84:0];

 
    assign gtx7_rx_data_to_fifo_i={gtx7_rx_data_vio_async_in_i,gtx7_rx_data_vio_sync_in_i,gtx7_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_7_i 
    (
	.rst(gtx7_rx_system_reset_c),
	.wr_clk(gtx7_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx7_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx7_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx7_rx_data_fifo_vio_async_in_i = gtx7_rx_data_from_fifo_i[148:117];

    assign gtx7_rx_data_fifo_vio_sync_in_i = gtx7_rx_data_from_fifo_i[116:85];

    assign gtx7_fifo_ila_in_i = gtx7_rx_data_from_fifo_i[84:0];

 
    assign gtx8_rx_data_to_fifo_i={gtx8_rx_data_vio_async_in_i,gtx8_rx_data_vio_sync_in_i,gtx8_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_8_i 
    (
	.rst(gtx8_rx_system_reset_c),
	.wr_clk(gtx8_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx8_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx8_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx8_rx_data_fifo_vio_async_in_i = gtx8_rx_data_from_fifo_i[148:117];

    assign gtx8_rx_data_fifo_vio_sync_in_i = gtx8_rx_data_from_fifo_i[116:85];

    assign gtx8_fifo_ila_in_i = gtx8_rx_data_from_fifo_i[84:0];

 
    assign gtx9_rx_data_to_fifo_i={gtx9_rx_data_vio_async_in_i,gtx9_rx_data_vio_sync_in_i,gtx9_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_9_i 
    (
	.rst(gtx9_rx_system_reset_c),
	.wr_clk(gtx9_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx9_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx9_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx9_rx_data_fifo_vio_async_in_i = gtx9_rx_data_from_fifo_i[148:117];

    assign gtx9_rx_data_fifo_vio_sync_in_i = gtx9_rx_data_from_fifo_i[116:85];

    assign gtx9_fifo_ila_in_i = gtx9_rx_data_from_fifo_i[84:0];

 
    assign gtx10_rx_data_to_fifo_i={gtx10_rx_data_vio_async_in_i,gtx10_rx_data_vio_sync_in_i,gtx10_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_10_i 
    (
	.rst(gtx10_rx_system_reset_c),
	.wr_clk(gtx10_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx10_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx10_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx10_rx_data_fifo_vio_async_in_i = gtx10_rx_data_from_fifo_i[148:117];

    assign gtx10_rx_data_fifo_vio_sync_in_i = gtx10_rx_data_from_fifo_i[116:85];

    assign gtx10_fifo_ila_in_i = gtx10_rx_data_from_fifo_i[84:0];

 
    assign gtx11_rx_data_to_fifo_i={gtx11_rx_data_vio_async_in_i,gtx11_rx_data_vio_sync_in_i,gtx11_ila_in_i};

    rx_phase_align_fifo rx_phase_align_fifo_11_i 
    (
	.rst(gtx11_rx_system_reset_c),
	.wr_clk(gtx11_rxusrclk2_i),
	.rd_clk(rx_vio_ila_clk_i),
	.din(gtx11_rx_data_to_fifo_i),  
	.wr_en(1'b1),
	.rd_en(1'b1),
	.dout(gtx11_rx_data_from_fifo_i),  
	.full(),
	.empty()
    );

    assign gtx11_rx_data_fifo_vio_async_in_i = gtx11_rx_data_from_fifo_i[148:117];

    assign gtx11_rx_data_fifo_vio_sync_in_i = gtx11_rx_data_from_fifo_i[116:85];

    assign gtx11_fifo_ila_in_i = gtx11_rx_data_from_fifo_i[84:0];


    // assign resets for frame_gen modules

    // assign resets for frame_check modules
    assign  gtx0_rx_system_reset_c = !gtx0_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx1_rx_system_reset_c = !gtx1_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx2_rx_system_reset_c = !gtx2_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx3_rx_system_reset_c = !gtx3_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx4_rx_system_reset_c = !gtx4_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx5_rx_system_reset_c = !gtx5_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx6_rx_system_reset_c = !gtx6_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx7_rx_system_reset_c = !gtx7_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx8_rx_system_reset_c = !gtx8_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx9_rx_system_reset_c = !gtx9_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx10_rx_system_reset_c = !gtx10_rxresetdone_r3 || user_rx_reset_i;
    assign  gtx11_rx_system_reset_c = !gtx11_rxresetdone_r3 || user_rx_reset_i;

    assign  gtx0_gtxrxreset_i = gtxrxreset_i;
    assign  gtx1_gtxrxreset_i = gtxrxreset_i;
    assign  gtx2_gtxrxreset_i = gtxrxreset_i;
    assign  gtx3_gtxrxreset_i = gtxrxreset_i;
    assign  gtx4_gtxrxreset_i = gtxrxreset_i;
    assign  gtx5_gtxrxreset_i = gtxrxreset_i;
    assign  gtx6_gtxrxreset_i = gtxrxreset_i;
    assign  gtx7_gtxrxreset_i = gtxrxreset_i;
    assign  gtx8_gtxrxreset_i = gtxrxreset_i;
    assign  gtx9_gtxrxreset_i = gtxrxreset_i;
    assign  gtx10_gtxrxreset_i = gtxrxreset_i;
    assign  gtx11_gtxrxreset_i = gtxrxreset_i;

    // Shared VIO Outputs
    assign  gtxrxreset_i                         =  shared_vio_out_i[31];
    assign  user_tx_reset_i                      =  shared_vio_out_i[30];
    assign  user_rx_reset_i                      =  shared_vio_out_i[29];
    assign  mux_sel_i                            =  shared_vio_out_i[28:25];

    // Shared VIO Inputs
    assign  shared_vio_in_i[31:0]                =  32'b00000000000000000000000000000000;

    // Chipscope connections on GTX 0
    assign  gtx0_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx0_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx0_rx_data_vio_async_in_i[31]      =  gtx0_rxplllkdet_i;
    assign  gtx0_rx_data_vio_async_in_i[30]      =  gtx0_rxresetdone_i;
    assign  gtx0_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx0_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx0_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx0_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx0_ila_in_i[84:83]                 =  gtx0_rxcharisk_i;
    assign  gtx0_ila_in_i[82:81]                 =  gtx0_rxdisperr_i;
    assign  gtx0_ila_in_i[80:79]                 =  gtx0_rxnotintable_i;
    assign  gtx0_ila_in_i[78:76]                 =  gtx0_rxclkcorcnt_i;
    assign  gtx0_ila_in_i[75:60]                 =  gtx0_rxdata_i;
    assign  gtx0_ila_in_i[59:52]                 =  gtx0_error_count_i;
    assign  gtx0_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 1
    assign  gtx1_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx1_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx1_rx_data_vio_async_in_i[31]      =  gtx1_rxplllkdet_i;
    assign  gtx1_rx_data_vio_async_in_i[30]      =  gtx1_rxresetdone_i;
    assign  gtx1_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx1_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx1_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx1_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx1_ila_in_i[84:83]                 =  gtx1_rxcharisk_i;
    assign  gtx1_ila_in_i[82:81]                 =  gtx1_rxdisperr_i;
    assign  gtx1_ila_in_i[80:79]                 =  gtx1_rxnotintable_i;
    assign  gtx1_ila_in_i[78:76]                 =  gtx1_rxclkcorcnt_i;
    assign  gtx1_ila_in_i[75:60]                 =  gtx1_rxdata_i;
    assign  gtx1_ila_in_i[59:52]                 =  gtx1_error_count_i;
    assign  gtx1_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 2
    assign  gtx2_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx2_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx2_rx_data_vio_async_in_i[31]      =  gtx2_rxplllkdet_i;
    assign  gtx2_rx_data_vio_async_in_i[30]      =  gtx2_rxresetdone_i;
    assign  gtx2_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx2_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx2_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx2_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx2_ila_in_i[84:83]                 =  gtx2_rxcharisk_i;
    assign  gtx2_ila_in_i[82:81]                 =  gtx2_rxdisperr_i;
    assign  gtx2_ila_in_i[80:79]                 =  gtx2_rxnotintable_i;
    assign  gtx2_ila_in_i[78:76]                 =  gtx2_rxclkcorcnt_i;
    assign  gtx2_ila_in_i[75:60]                 =  gtx2_rxdata_i;
    assign  gtx2_ila_in_i[59:52]                 =  gtx2_error_count_i;
    assign  gtx2_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 3
    assign  gtx3_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx3_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx3_rx_data_vio_async_in_i[31]      =  gtx3_rxplllkdet_i;
    assign  gtx3_rx_data_vio_async_in_i[30]      =  gtx3_rxresetdone_i;
    assign  gtx3_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx3_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx3_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx3_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx3_ila_in_i[84:83]                 =  gtx3_rxcharisk_i;
    assign  gtx3_ila_in_i[82:81]                 =  gtx3_rxdisperr_i;
    assign  gtx3_ila_in_i[80:79]                 =  gtx3_rxnotintable_i;
    assign  gtx3_ila_in_i[78:76]                 =  gtx3_rxclkcorcnt_i;
    assign  gtx3_ila_in_i[75:60]                 =  gtx3_rxdata_i;
    assign  gtx3_ila_in_i[59:52]                 =  gtx3_error_count_i;
    assign  gtx3_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 4
    assign  gtx4_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx4_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx4_rx_data_vio_async_in_i[31]      =  gtx4_rxplllkdet_i;
    assign  gtx4_rx_data_vio_async_in_i[30]      =  gtx4_rxresetdone_i;
    assign  gtx4_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx4_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx4_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx4_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx4_ila_in_i[84:83]                 =  gtx4_rxcharisk_i;
    assign  gtx4_ila_in_i[82:81]                 =  gtx4_rxdisperr_i;
    assign  gtx4_ila_in_i[80:79]                 =  gtx4_rxnotintable_i;
    assign  gtx4_ila_in_i[78:76]                 =  gtx4_rxclkcorcnt_i;
    assign  gtx4_ila_in_i[75:60]                 =  gtx4_rxdata_i;
    assign  gtx4_ila_in_i[59:52]                 =  gtx4_error_count_i;
    assign  gtx4_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 5
    assign  gtx5_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx5_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx5_rx_data_vio_async_in_i[31]      =  gtx5_rxplllkdet_i;
    assign  gtx5_rx_data_vio_async_in_i[30]      =  gtx5_rxresetdone_i;
    assign  gtx5_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx5_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx5_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx5_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx5_ila_in_i[84:83]                 =  gtx5_rxcharisk_i;
    assign  gtx5_ila_in_i[82:81]                 =  gtx5_rxdisperr_i;
    assign  gtx5_ila_in_i[80:79]                 =  gtx5_rxnotintable_i;
    assign  gtx5_ila_in_i[78:76]                 =  gtx5_rxclkcorcnt_i;
    assign  gtx5_ila_in_i[75:60]                 =  gtx5_rxdata_i;
    assign  gtx5_ila_in_i[59:52]                 =  gtx5_error_count_i;
    assign  gtx5_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 6
    assign  gtx6_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx6_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx6_rx_data_vio_async_in_i[31]      =  gtx6_rxplllkdet_i;
    assign  gtx6_rx_data_vio_async_in_i[30]      =  gtx6_rxresetdone_i;
    assign  gtx6_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx6_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx6_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx6_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx6_ila_in_i[84:83]                 =  gtx6_rxcharisk_i;
    assign  gtx6_ila_in_i[82:81]                 =  gtx6_rxdisperr_i;
    assign  gtx6_ila_in_i[80:79]                 =  gtx6_rxnotintable_i;
    assign  gtx6_ila_in_i[78:76]                 =  gtx6_rxclkcorcnt_i;
    assign  gtx6_ila_in_i[75:60]                 =  gtx6_rxdata_i;
    assign  gtx6_ila_in_i[59:52]                 =  gtx6_error_count_i;
    assign  gtx6_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 7
    assign  gtx7_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx7_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx7_rx_data_vio_async_in_i[31]      =  gtx7_rxplllkdet_i;
    assign  gtx7_rx_data_vio_async_in_i[30]      =  gtx7_rxresetdone_i;
    assign  gtx7_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx7_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx7_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx7_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx7_ila_in_i[84:83]                 =  gtx7_rxcharisk_i;
    assign  gtx7_ila_in_i[82:81]                 =  gtx7_rxdisperr_i;
    assign  gtx7_ila_in_i[80:79]                 =  gtx7_rxnotintable_i;
    assign  gtx7_ila_in_i[78:76]                 =  gtx7_rxclkcorcnt_i;
    assign  gtx7_ila_in_i[75:60]                 =  gtx7_rxdata_i;
    assign  gtx7_ila_in_i[59:52]                 =  gtx7_error_count_i;
    assign  gtx7_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 8
    assign  gtx8_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx8_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx8_rx_data_vio_async_in_i[31]      =  gtx8_rxplllkdet_i;
    assign  gtx8_rx_data_vio_async_in_i[30]      =  gtx8_rxresetdone_i;
    assign  gtx8_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx8_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx8_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx8_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx8_ila_in_i[84:83]                 =  gtx8_rxcharisk_i;
    assign  gtx8_ila_in_i[82:81]                 =  gtx8_rxdisperr_i;
    assign  gtx8_ila_in_i[80:79]                 =  gtx8_rxnotintable_i;
    assign  gtx8_ila_in_i[78:76]                 =  gtx8_rxclkcorcnt_i;
    assign  gtx8_ila_in_i[75:60]                 =  gtx8_rxdata_i;
    assign  gtx8_ila_in_i[59:52]                 =  gtx8_error_count_i;
    assign  gtx8_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 9
    assign  gtx9_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx9_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx9_rx_data_vio_async_in_i[31]      =  gtx9_rxplllkdet_i;
    assign  gtx9_rx_data_vio_async_in_i[30]      =  gtx9_rxresetdone_i;
    assign  gtx9_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx9_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx9_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx9_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx9_ila_in_i[84:83]                 =  gtx9_rxcharisk_i;
    assign  gtx9_ila_in_i[82:81]                 =  gtx9_rxdisperr_i;
    assign  gtx9_ila_in_i[80:79]                 =  gtx9_rxnotintable_i;
    assign  gtx9_ila_in_i[78:76]                 =  gtx9_rxclkcorcnt_i;
    assign  gtx9_ila_in_i[75:60]                 =  gtx9_rxdata_i;
    assign  gtx9_ila_in_i[59:52]                 =  gtx9_error_count_i;
    assign  gtx9_ila_in_i[51:0]                  =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 10
    assign  gtx10_tx_data_vio_async_in_i[31:0]   =  32'b00000000000000000000000000000000;
    assign  gtx10_tx_data_vio_sync_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx10_rx_data_vio_async_in_i[31]     =  gtx10_rxplllkdet_i;
    assign  gtx10_rx_data_vio_async_in_i[30]     =  gtx10_rxresetdone_i;
    assign  gtx10_rx_data_vio_async_in_i[29:0]   =  30'b000000000000000000000000000000;
    assign  gtx10_rx_data_vio_sync_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx10_pllrxreset_i                   =  rx_data_vio_async_out_i[31];
    assign  gtx10_rxpowerdown_i                  =  rx_data_vio_async_out_i[30:29];
    assign  gtx10_ila_in_i[84:83]                =  gtx10_rxcharisk_i;
    assign  gtx10_ila_in_i[82:81]                =  gtx10_rxdisperr_i;
    assign  gtx10_ila_in_i[80:79]                =  gtx10_rxnotintable_i;
    assign  gtx10_ila_in_i[78:76]                =  gtx10_rxclkcorcnt_i;
    assign  gtx10_ila_in_i[75:60]                =  gtx10_rxdata_i;
    assign  gtx10_ila_in_i[59:52]                =  gtx10_error_count_i;
    assign  gtx10_ila_in_i[51:0]                 =  52'b0000000000000000000000000000000000000000000000000000;

    // Chipscope connections on GTX 11
    assign  gtx11_tx_data_vio_async_in_i[31:0]   =  32'b00000000000000000000000000000000;
    assign  gtx11_tx_data_vio_sync_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx11_rx_data_vio_async_in_i[31]     =  gtx11_rxplllkdet_i;
    assign  gtx11_rx_data_vio_async_in_i[30]     =  gtx11_rxresetdone_i;
    assign  gtx11_rx_data_vio_async_in_i[29:0]   =  30'b000000000000000000000000000000;
    assign  gtx11_rx_data_vio_sync_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx11_pllrxreset_i                   =  rx_data_vio_async_out_i[31];
    assign  gtx11_rxpowerdown_i                  =  rx_data_vio_async_out_i[30:29];
    assign  gtx11_ila_in_i[84:83]                =  gtx11_rxcharisk_i;
    assign  gtx11_ila_in_i[82:81]                =  gtx11_rxdisperr_i;
    assign  gtx11_ila_in_i[80:79]                =  gtx11_rxnotintable_i;
    assign  gtx11_ila_in_i[78:76]                =  gtx11_rxclkcorcnt_i;
    assign  gtx11_ila_in_i[75:60]                =  gtx11_rxdata_i;
    assign  gtx11_ila_in_i[59:52]                =  gtx11_error_count_i;
    assign  gtx11_ila_in_i[51:0]                 =  52'b0000000000000000000000000000000000000000000000000000;


    //Mux inputs to Chipscope modules based on mux_sel_i

    assign  tx_data_vio_async_in_i =    (mux_sel_i == 4'b0000)?gtx0_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0001)?gtx1_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0010)?gtx2_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0011)?gtx3_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0100)?gtx4_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0101)?gtx5_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0110)?gtx6_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b0111)?gtx7_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b1000)?gtx8_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b1001)?gtx9_tx_data_vio_async_in_i:
                                        (mux_sel_i == 4'b1010)?gtx10_tx_data_vio_async_in_i:
                                                               gtx11_tx_data_vio_async_in_i;


    assign  tx_data_vio_sync_in_i =     (mux_sel_i == 4'b0000)?gtx0_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0001)?gtx1_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0010)?gtx2_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0011)?gtx3_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0100)?gtx4_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0101)?gtx5_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0110)?gtx6_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b0111)?gtx7_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b1000)?gtx8_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b1001)?gtx9_tx_data_vio_sync_in_i:
                                        (mux_sel_i == 4'b1010)?gtx10_tx_data_vio_sync_in_i:
                                                               gtx11_tx_data_vio_sync_in_i;

    assign  rx_data_vio_async_in_i =    (mux_sel_i == 4'b0000)?gtx0_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0001)?gtx1_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0010)?gtx2_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0011)?gtx3_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0100)?gtx4_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0101)?gtx5_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0110)?gtx6_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b0111)?gtx7_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b1000)?gtx8_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b1001)?gtx9_rx_data_fifo_vio_async_in_i:
                                        (mux_sel_i == 4'b1010)?gtx10_rx_data_fifo_vio_async_in_i:
                                                               gtx11_rx_data_fifo_vio_async_in_i;


    assign  rx_data_vio_sync_in_i =     (mux_sel_i == 4'b0000)?gtx0_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0001)?gtx1_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0010)?gtx2_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0011)?gtx3_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0100)?gtx4_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0101)?gtx5_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0110)?gtx6_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b0111)?gtx7_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b1000)?gtx8_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b1001)?gtx9_rx_data_fifo_vio_sync_in_i:
                                        (mux_sel_i == 4'b1010)?gtx10_rx_data_fifo_vio_sync_in_i:
                                                               gtx11_rx_data_fifo_vio_sync_in_i;


    assign  ila_in_i =                  (mux_sel_i == 4'b0000)?gtx0_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0001)?gtx1_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0010)?gtx2_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0011)?gtx3_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0100)?gtx4_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0101)?gtx5_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0110)?gtx6_fifo_ila_in_i:
                                        (mux_sel_i == 4'b0111)?gtx7_fifo_ila_in_i:
                                        (mux_sel_i == 4'b1000)?gtx8_fifo_ila_in_i:
                                        (mux_sel_i == 4'b1001)?gtx9_fifo_ila_in_i:
                                        (mux_sel_i == 4'b1010)?gtx10_fifo_ila_in_i:
                                                               gtx11_fifo_ila_in_i;

end //end EXAMPLE_USE_CHIPSCOPE=1 generate section
else 
begin: no_chipscope

    // If Chipscope is not being used, drive GTX reset signal
    // from the top level ports
    assign  gtx0_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx1_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx2_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx3_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx4_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx5_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx6_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx7_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx8_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx9_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx10_gtxrxreset_i = GTXRXRESET_IN;
    assign  gtx11_gtxrxreset_i = GTXRXRESET_IN;

    // assign resets for frame_gen modules

    // assign resets for frame_check modules
    assign  gtx0_rx_system_reset_c = !gtx0_rxresetdone_r3;
    assign  gtx1_rx_system_reset_c = !gtx1_rxresetdone_r3;
    assign  gtx2_rx_system_reset_c = !gtx2_rxresetdone_r3;
    assign  gtx3_rx_system_reset_c = !gtx3_rxresetdone_r3;
    assign  gtx4_rx_system_reset_c = !gtx4_rxresetdone_r3;
    assign  gtx5_rx_system_reset_c = !gtx5_rxresetdone_r3;
    assign  gtx6_rx_system_reset_c = !gtx6_rxresetdone_r3;
    assign  gtx7_rx_system_reset_c = !gtx7_rxresetdone_r3;
    assign  gtx8_rx_system_reset_c = !gtx8_rxresetdone_r3;
    assign  gtx9_rx_system_reset_c = !gtx9_rxresetdone_r3;
    assign  gtx10_rx_system_reset_c = !gtx10_rxresetdone_r3;
    assign  gtx11_rx_system_reset_c = !gtx11_rxresetdone_r3;

    assign  gtxrxreset_i                         =  tied_to_ground_i;
    assign  user_tx_reset_i                      =  tied_to_ground_i;
    assign  user_rx_reset_i                      =  tied_to_ground_i;
    assign  mux_sel_i                            =  tied_to_ground_vec_i[3:0];
    assign  gtx0_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx0_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx1_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx1_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx2_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx2_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx3_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx3_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx4_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx4_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx5_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx5_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx6_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx6_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx7_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx7_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx8_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx8_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx9_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx9_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx10_pllrxreset_i                   =  tied_to_ground_i;
    assign  gtx10_rxpowerdown_i                  =  tied_to_ground_vec_i[1:0];
    assign  gtx11_pllrxreset_i                   =  tied_to_ground_i;
    assign  gtx11_rxpowerdown_i                  =  tied_to_ground_vec_i[1:0];


end
endgenerate //End generate for EXAMPLE_USE_CHIPSCOPE


endmodule

//-------------------------------------------------------------------
//
//  VIO core module declaration
//
//-------------------------------------------------------------------
module data_vio
  (
    control,
    clk,
    async_in,
    async_out,
    sync_in,
    sync_out
  );
  inout  [35:0] control;
  input         clk;
  input  [31:0] async_in;
  output [31:0] async_out;
  input  [31:0] sync_in;
  output [31:0] sync_out;
endmodule


//-------------------------------------------------------------------
//
//  ICON core module declaration
//
//-------------------------------------------------------------------
module icon
  (
      control0,
      control1,
      control2,
      control3
  );
  inout [35:0] control0;
  inout [35:0] control1;
  inout [35:0] control2;
  inout [35:0] control3;
endmodule


//-------------------------------------------------------------------
//
//  ILA core module declaration
//  This is used to allow RX signals to be monitored
//
//-------------------------------------------------------------------
module ila
  (
    control,
    clk,
    trig0
  );
  inout [35:0] control;
  input clk;
  input [84:0] trig0;
endmodule

module rx_phase_align_fifo
  (
    rst,
    wr_clk,
    rd_clk,
    din,
    wr_en,
    rd_en,
    dout,
    full,
    empty
  );


  input rst;
  input wr_clk;
  input rd_clk;
  input [148:0] din;
  input wr_en;
  input rd_en;
  output [148:0] dout;
  output full;
  output empty;
endmodule 

